SystemOrganization addCategory: #'Khami-Web'!

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'css' stamp: 'StuartHerring 3/20/2011 15:45'!
styleCss
	^'html {
	background: #aaccff;
}

.clickable {
	cursor: pointer;
}

.summary {
	float: right;
	background: silver;
	padding: 0.5em;
	border: 1px solid black;
	margin: 0;
}

.summary dt {
	float: left;
	clear: left;
	font-weight: bold;
	width: 4em;
}

.summary dd {
	float: left;
	clear: right;
	margin-left: 0.5em;
	width: 3em;
}

ul.menu { 
	padding: 0;
	margin: 0;
	margin-bottom: 5px;
	background: gray;
}

.menu li {
	display: inline;
	padding-left: 3px;
	padding-right: 3px;
	margin: 0;
}

.menu li:hover {
	background: silver;
}
.menu li a {
text-decoration: none;
	color: white;
	margin: 0;
}

.menu li a:hover {
	color: gray;
}

table.gameBoard {
	border-collapse: collapse;
	border-color: gray;
	padding: 0;
}

table.gameBoard td {
	width: 52px;
	height: 52px;
	padding: 0px;
}

table.gameBoard td.available {
	background-color: white;
}

table.gameBoard td.available:hover {
	background-color: silver;
}

table.gameBoard td.available a {
	display: block;
	margin: 0;
	height: 100%;
	width: 100%;
	text-decoration: none;
}

table.KmTile {
	border: 1px black solid;
	padding: 0;
	border-spacing: 0;
	border-collapse: collapse;
}

table.KmTile td {
	width: 10px;
	height: 10px;
	background-color: silver;
	padding: 0;
}

table.KmTile td.text {
	width: 50px;
	height: 50px;
	text-align: center;
}

.KmTile td.farm {
	background: green;
}

.KmTile td.farmC {
	background: lime;
}

.KmTile td.village {
	background: maroon;
}

.KmTile td.villageC {
	background: red;
}

.KmTile td.road {
	background: white;
}

.KmTile td.roadC {
	background: black;
}
'! !

WAComponent subclass: #KmChooseTileSet
	instanceVariableNames: 'tileSets tileSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmChooseTileSet class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 08:54'!
canBeRoot
	^true! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 15:33'!
initialize
	super initialize.
	tileSets := KmTileSet tileSets asOrderedCollection.
	tileSet := tileSets first.! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 09:37'!
renderContentOn: html
	html heading level: 1; with: 'Choose a tile set'.
	html form: [
		self renderTileSetsOn: html.
		html submitButton callback: [ self submitClicked]; with: 'Ok'].! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2011 23:07'!
renderTileSetsOn: html
	html select 
		on: #tileSet of: self; 
		list: tileSets;
		labels: [ :ts | ts tilesetName]! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 09:39'!
submitClicked
	self answer: tileSet! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 09:01'!
tileSet
	^tileSet! !

!KmChooseTileSet methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2011 10:12'!
tileSet: aSet
	tileSet := aSet! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'instance creation' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
at: row at: column
	^game board at: row at: column! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
columns 
	^game board columns! !

!KmGameBoardComponent methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 10:45'!
initializeWithGame: aGame
	self initialize.
	game:= aGame! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:50'!
placeTileAt: row at: column
	game placeTileAt: row at: column! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:33'!
renderAvailableSpotFor: row at: column on: html
	html tableData class: #available; 
		onClick: ('window.location="', (html urlForAction: [self placeTileAt: row at: column]) printString, '"').
! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:38'!
renderBlankSpotOn: html
	html tableData.! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:22'!
renderContentOn: html
	html table border: 1; class: 'gameBoard';with: [
		1 to: self rows do: [ :r |
			html tableRow: [
				1 to: self columns do: [ :c |
					self renderTileAt: r at: c on: html]]]]! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:38'!
renderOccupiedSpotFor: aTile on: html
	html tableData: 	(KmTileRenderable for: aTile)! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 1/17/2011 20:25'!
renderTileAt: row at: column on: html
	(self tileIsValidAt: row at: column)
		ifTrue: [self renderAvailableSpotFor: row at: column on: html]
		ifFalse: [ | tile |
			tile := self at: row at: column.
			tile isNil 
				ifTrue: [self renderBlankSpotOn: html]
				ifFalse: [self renderOccupiedSpotFor: tile on: html]]! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
rows
	^game board rows! !

!KmGameBoardComponent methodsFor: 'testing' stamp: 'StuartHerring 1/17/2011 22:49'!
tileIsValidAt: row at: column
	| regions gameBoard |
	game currentTile ifNil: [^false].
	gameBoard := game board.
	^gameBoard canPlaceTile: game currentTile at: row at: column.! !

WAComponent subclass: #KmHome
	instanceVariableNames: 'gameBoard summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmHome methodsFor: 'hooks' stamp: 'StuartHerring 1/30/2011 23:15'!
children
	^Array with: gameBoard with: summary.! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 3/14/2011 11:58'!
game
	^self session game! !

!KmHome methodsFor: 'initialization' stamp: 'StuartHerring 3/14/2011 11:58'!
initialize
	super initialize.
	gameBoard := KmGameBoardComponent for: self game.
	summary := KmTerritorySummary new.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 12:34'!
renderContentOn: html
	self renderMenuOn: html.
	html render: summary.
	self renderCurrentTileOn: html.
	self renderGameBoardOn: html.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 12:36'!
renderCurrentTileOn: html
		self session currentTile 
			ifNil: [html render: 
				((KmTextTileRenderable text: 'Take Tile') callback: [self takeTile])]
			ifNotNil: [html render: 
				((KmTileRenderable for: self session currentTile) callback: [self rotateTile])].
! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/9/2011 18:37'!
renderMenuItem: text do: aBlock on: html
	html listItem: [html anchor callback: aBlock; with: text ]! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 12:46'!
renderMenuOn: html
	| currentTile |
	currentTile := self session currentTile.
	html unorderedList 
		class: #menu;
		with: [
			self renderMenuItem: 'Show Remaining Tiles' do: [ self showRemaining ] on: html.
			self renderMenuItem: 'Show Territory Info' do: [self showTerritories] on: html.
			currentTile ifNotNil: [ self renderMenuItem: 'Rotate Tile' do: [self rotateTile] on: html ]]! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/18/2011 19:42'!
rotateTile
	self session currentTile rotate! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/9/2011 18:32'!
showRemaining
	self call: KmTileList new.! !

!KmHome methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:57'!
showTerritories
	self call: KmTerritoryInfo new.! !

!KmHome methodsFor: 'actions' stamp: 'StuartHerring 1/17/2011 10:55'!
takeTile
	self session game takeTile! !

!KmHome methodsFor: 'updating' stamp: 'StuartHerring 3/14/2011 12:16'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss).
	anHtmlRoot title: 'Villages of Khami: ', self game tileSet name.
		
! !

WAComponent subclass: #KmTerritoryInfo
	instanceVariableNames: 'summary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritoryInfo methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:14'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html heading level: 2; with: 'Territory Information'.
	html render: summary.
	html anchor callback: [ self answer]; with: 'Close'.! !

!KmTerritoryInfo methodsFor: 'updating' stamp: 'StuartHerring 1/30/2011 23:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss)! !

WAComponent subclass: #KmTerritorySummary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:46'!
render: aCollection named: aString on: html
	html definitionTerm: aString.
	html definitionData: [
		html render: aCollection size;
			render: ' (';
			render: (aCollection select: [ :t | t isComplete ]) size;
			render: ')']! !

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 1/31/2011 00:02'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html definitionList class: #summary; with: [ 
		self render: (territories select: [ :t | t type = #road]) named: 'Roads' on: html.
		self render: (territories select: [ :t | t type = #farm]) named: 'Farms' on: html.
		self render: (territories select: [ :t | t type = #village]) named: 'Villages' on: html.
		self render: territories  named: 'Total' on: html.
	].
! !

WAComponent subclass: #KmTileList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 12:18'!
game
	^self session game! !

!KmTileList methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 12:10'!
initialize
	super initialize.! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:48'!
renderContentOn: html
	html heading level: 2; with: 'Tiles Remaining: ', self game tileSet name.	
	self session game remainingTiles do: [ :t |
		html div style: 'display: inline-block'; with: (KmTileRenderable for: t)].
	html break.
	html anchor callback: [ self answer ]; with: 'Close'
! !

!KmTileList methodsFor: 'updating' stamp: 'StuartHerring 3/14/2011 12:17'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss).
	anHtmlRoot title: 'Tiles Remaining: ', self game tileSet name! !

WATask subclass: #KmGameTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameTask class methodsFor: 'class initialization' stamp: 'StuartHerring 3/14/2011 08:54'!
initialize
	| app |
	WAAdmin register: self asApplicationAt: 'vok'.
	WADispatcher default defaultName: 'vok'.
	app := WADispatcher default defaultHandler.
	app preferenceAt: #sessionClass put: KmSession ! !

!KmGameTask methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2011 23:07'!
go
	| tileSet |
	tileSet := self call: KmChooseTileSet new.
	self session startGameWithTileSet: tileSet new.
	self call: KmHome new.	! !

WASession subclass: #KmSession
	instanceVariableNames: 'game frozen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:42'!
currentTile
	^game currentTile! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
freeze
	frozen := true! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/9/2011 18:28'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 3/14/2011 09:46'!
initialize
	super initialize.
	frozen := false.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 1/9/2011 18:30'!
initializeGame
	game := KmGame testGame.! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:26'!
isFrozen
	^frozen! !

!KmSession methodsFor: 'actions' stamp: 'StuartHerring 3/14/2011 10:05'!
startGameWithTileSet: aTileSet
	game := KmGame tileSet: aTileSet! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
unfreeze
	frozen := false! !

Object subclass: #KmBlankTileRenderable
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmBlankTileRenderable methodsFor: 'accessing' stamp: 'StuartHerring 3/20/2011 12:24'!
callback: aBlock
	callback := aBlock! !

!KmBlankTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:26'!
initialize
	 super initialize.
	callback := nil	! !

!KmBlankTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:42'!
renderOn: html
	html table
		onClick: (callback ifNotNil: ['window.location = "', (html urlForAction:  callback) printString, '";']);
		class: (KmTile name); 
		class: (callback ifNotNil: ['clickable']);
			with: [self renderTileOn: html]! !

KmBlankTileRenderable subclass: #KmTextTileRenderable
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTextTileRenderable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:33'!
text: aString 
	^self basicNew
		initializeWithText: aString;
		yourself! !

!KmTextTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 12:33'!
initializeWithText: aString
	self initialize.
	text := aString! !

!KmTextTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/20/2011 14:24'!
renderTileOn: html
	html tableRow: [html tableData class: 'text'; with: text]! !

KmBlankTileRenderable subclass: #KmTileRenderable
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/31/2011 23:07'!
classFor: aRegion
	^String streamContents: [ :s |
		s nextPutAll: aRegion type.
		aRegion isComplete ifTrue: [s nextPut: $C]]! !

!KmTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 3/20/2011 12:25'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:24'!
renderBlankOn: html
	html tableData! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:09'!
renderHorizontalPathAt: side on: html
	html tableData 
			colSpan: 2;
			class: (self classFor: (tile at: side))! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:10'!
renderPath: aPath on: html
	html tableData 
		class: (self classFor: aPath)! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:10'!
renderRegion: aRegion on: html
	html tableData 
		class: (self classFor: aRegion)! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:22'!
renderRegionOrBlankAt: region on: html
	((tile at: region) connectsTo: (tile at: region connectingLocations first))
		ifTrue: [self renderRegion: (tile at: region) on: html]
		ifFalse: [ self renderBlankOn: html]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 12:28'!
renderTileOn: html
		html tableRow: [
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegion: (tile at: TopLeft) on: html.
			self renderVerticalPathAt: Top on: html.
			self renderRegion: (tile at: TopRight) on: html.
			self renderRegionOrBlankAt: TopRight on: html.
		].
		html tableRow: [ 
			self renderRegion: (tile at: LeftTop) on: html.
			self renderRegionOrBlankAt: LeftTop on: html.
			self renderRegionOrBlankAt: TopRight on: html.
			self renderRegion: (tile at: RightTop) on: html.
		].
		html tableRow: [
			self renderHorizontalPathAt: Left on: html.
			self renderPath: (tile at: Centre) on: html.
			self renderHorizontalPathAt: Right on: html
			].
		html tableRow: [ 
			self renderRegion: (tile at: LeftBottom) on: html.
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderVerticalPathAt: Bottom on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
			self renderRegion: (tile at: RightBottom) on: html.
		].
		html tableRow: [
			self renderRegionOrBlankAt: BottomLeft on: html.
			self renderRegion: (tile at: BottomLeft) on: html.
			self renderRegion: (tile at: BottomRight) on: html.
			self renderRegionOrBlankAt: RightBottom on: html.
		]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 22:18'!
renderVerticalPathAt: side on: html
	html tableData 
			rowSpan: 2;
			class: (self classFor: (tile at: side))! !
KmGameTask initialize!
